Summary: The shared library for the S-Lang extension language
Name: slang
Version: 2.1.3
Release: 1
License: GPLv2+
Group: System Environment/Libraries
Source0: ftp://space.mit.edu/pub/davis/slang/v2.1/%{name}-%{version}.tar.bz2
Source1: ftp://space.mit.edu/pub/davis/slang/v2.1/%{name}-%{version}.tar.bz2.asc
Patch0: %{name}-%{version}-aix.patch
URL: http://www.jedsoft.org/slang/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: libpng-devel pcre-devel

%description
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.


%package slsh
Summary: Interpreter for S-Lang scripts
Group: Development/Languages
Requires: %{name} = %{version}-%{release}

%description slsh
slsh (slang-shell) is a program for interpreting S-Lang scripts. 
It supports dynamic loading of S-Lang modules and includes a readline
interface for interactive use.

This package also includes S-Lang modules that are distributed with
the S-Lang distribution.


%package devel
Summary: Development files for the S-Lang extension language
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains files which you'll need if you want to
develop S-Lang based applications.  Documentation which may help
you write S-Lang based applications is also included.

Install the slang-devel package if you want to develop applications
based on the S-Lang extension language.


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit/


%build
# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export OBJECT_MODE=64
export CC="cc -q64"
cd 64bit
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --disable-shared --enable-static
make %{?_smp_mflags} static

CreateExportList -X64 lib%{name}.exp src/objs/lib%{name}.a
${CC} -qmkshrobj src/objs/lib%{name}.a -o shr64.o -bE:lib%{name}.exp -lm
rm -f lib%{name}.exp

# now build the 32-bit version
export OBJECT_MODE=32
export CC="cc"
cd ../32bit
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --disable-shared --enable-static
make %{?_smp_mflags} static

CreateExportList -X32 lib%{name}.exp src/objs/lib%{name}.a
${CC} -qmkshrobj src/objs/lib%{name}.a -o shr.o -bE:lib%{name}.exp -lm
rm -f lib%{name}.exp src/objs/lib%{name}.a
${AR} -rv src/objs/lib%{name}.a shr.o


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install-static

cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install-static
cd slsh
make DESTDIR=${RPM_BUILD_ROOT} install
rm slsh
make slsh
cp slsh ${RPM_BUILD_ROOT}%{_bindir}

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
${AR} -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ../../64bit/shr64.o

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc 32bit/COPYING 32bit/doc/README 32bit/changes.txt
%doc 32bit/doc/*/slang*.txt 32bit/doc/*.txt
%{_libdir}/*.a
/usr/lib/*.a


%files slsh
%defattr(-,root,system)
%doc 32bit/slsh/doc/html/slsh*.html
%config(noreplace) %{_sysconfdir}/slsh.rc
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/slsh
/usr/bin/*


%files devel
%defattr(-,root,system)
%doc 32bit/doc/*/cslang*.txt 32bit/doc/*/cref.txt
%{_includedir}/*
/usr/include/*


%changelog
* Tue Sep 09 2008 Michael Perzl <michael@perzl.org> - 2.1.3-1
- first version for AIX V5.1 and higher
